using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Eco.Handles;
using Eco.Windows.Forms;
using Eco.WinForm;
using Eco.ObjectRepresentation;
using Eco.Services;

using ECO_ORMBattle_SimpleExample.Model;


namespace ECO_ORMBattle_SimpleExample
{
    /// <summary>
    /// Summary description for ManageInvoices.
    /// </summary>
    public partial class ManageInvoices : System.Windows.Forms.Form
    {

        public ManageInvoices(ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace ecoSpace)
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            // Set EcoSpace (actually stores it in rhRoot.EcoSpace)
            // Note that you need to set the EcoSpace property for 
            // each ReferenceHandle and VariableHandle you add to 
            // the form.
            rhRoot.EcoSpace = ecoSpace;
        }

        public ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace EcoSpace
        {
            get { return (ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace)rhRoot.EcoSpace; }
        }

        private void btnAddToInvoice_Click(object sender, EventArgs e)
        {
            // Add the currently selected product to the invoice's items
            btnAddToInvoice.Enabled = false;
            try
            {
                if (cmhCurrentProduct.Element != null)
                {
                    Product prod = cmhCurrentProduct.Element.AsObject as Product;
                    if (prod != null)
                    {
                        Invoice inv = cmhCurrentInvoice.Element.AsObject as Invoice;
                        if (inv != null)
                        {
                            inv.Products.Add(prod);
                        }
                    }
                }
            }
            finally
            {
                btnAddToInvoice.Enabled = true;
            }
        }

        private void btnRemoveFromInvioce_Click(object sender, EventArgs e)
        {
            btnRemoveFromInvioce.Enabled = false;
            try
            {
                if (cmhCurrentInvoiceItem.Element != null)
                {
                    Product prod = cmhCurrentInvoiceItem.Element.AsObject as Product;
                    if (prod != null)
                    {
                        Invoice inv = cmhCurrentInvoiceItem.Element.AsObject as Invoice;
                        if (inv != null)
                        {
                            inv.Products.Remove(prod);
                        }
                    }
                }
            }
            finally
            {
                btnRemoveFromInvioce.Enabled = true;
            }
        }

        private void btnConfirm_Click(object sender, EventArgs e)
        {
            if (cmhCurrentInvoice.Element != null)
            {
                Invoice inv = cmhCurrentInvoice.Element.AsObject as Invoice;
                if (inv != null)
                {
                    inv.ConfirmInvoice();
                }
            }
        }

        private void btnCancelInvoice_Click(object sender, EventArgs e)
        {
            if (cmhCurrentInvoice.Element != null)
            {
                Invoice inv = cmhCurrentInvoice.Element.AsObject as Invoice;
                if (inv != null)
                {
                    inv.CancelInvoice();
                }
            }
        }

        private void btnDispatchInvoice_Click(object sender, EventArgs e)
        {
            if (cmhCurrentInvoice.Element != null)
            {
                Invoice inv = cmhCurrentInvoice.Element.AsObject as Invoice;
                if (inv != null)
                {
                    inv.DispatchInvoice();
                }
            }
        }

        private void btnReviewInvoice_Click(object sender, EventArgs e)
        {
            if (cmhCurrentInvoice.Element != null)
            {
                Invoice inv = cmhCurrentInvoice.Element.AsObject as Invoice;
                if (inv != null)
                {
                    inv.ReviewInvoice();
                }
            }
        }
    }
}
